<?php

namespace App\DataTables;

use App\Models\SemesterExam;
use Carbon\Carbon;
use Illuminate\Support\Facades\Auth;
use Yajra\DataTables\Html\Button;
use Yajra\DataTables\Html\Column;
use Yajra\DataTables\Html\Editor\Editor;
use Yajra\DataTables\Html\Editor\Fields;
use Yajra\DataTables\Services\DataTable;

class ExamsDataTable extends DataTable
{
    /**
     * Build DataTable class.
     *
     * @param mixed $query Results from query() method.
     * @return \Yajra\DataTables\DataTableAbstract
     */
    public function dataTable($query)
    {
        return datatables()
            ->eloquent($query)
            ->addColumn('Action', 'admin.exams.action')
            ->rawColumns([
                'Action',
            ])
            ->setRowId(function ($record) {
                return 'row_' . $record->id;
            })
            ->editColumn('created_at', function ($record) {
                return $record->created_at ? with(new Carbon($record->created_at))->format('Y-m-d H:i') : '';
            })
            ->filterColumn('division', function ($query, $keyword) {
                $keywords = trim($keyword);
                $query->whereRaw("divisions.title like ?", ["%{$keywords}%"]);
             })
             ->filterColumn('study_material', function ($query, $keyword) {
                $keywords = trim($keyword);
                $query->whereRaw("study_materials.title like ?", ["%{$keywords}%"]);
             })
    
            ->filterColumn('level', function ($query, $keyword) {
                $keywords = trim($keyword);
                $query->whereRaw("levels.title like ?", ["%{$keywords}%"]);
             })
            ->addIndexColumn();
    }


    public function lang()
    {

        $langJson = [
            "sEmptyTable"     =>  trans('general.datatable.sEmptyTable'),
            "sInfo"           =>  trans('general.datatable.sInfo'),
            "sInfoEmpty"      =>  trans('general.datatable.sInfoEmpty'),
            "sInfoFiltered"   =>  trans('general.datatable.sInfoFiltered'),
            "sInfoPostFix"    =>  trans('general.datatable.sInfoPostFix'),
            "sInfoThousands"  =>  trans('general.datatable.sInfoThousands'),
            "sLengthMenu"     =>  trans('general.datatable.sLengthMenu'),
            "sLoadingRecords" =>  trans('general.datatable.sLoadingRecords'),
            "sProcessing"     =>  trans('general.datatable.sProcessing'),
            "sSearch"         =>  trans('general.datatable.sSearch'),
            "sZeroRecords"    =>  trans('general.datatable.sZeroRecords'),
            "sFirst"          =>  trans('general.datatable.sFirst'),
            "sLast"           =>  trans('general.datatable.sLast'),
            "sNext"           =>  trans('general.datatable.sNext'),
            "sPrevious"       =>  trans('general.datatable.sPrevious'),
            "sSortAscending"  =>  trans('general.datatable.sSortAscending'),
            "sSortDescending" =>  trans('general.datatable.sSortDescending'),
            "paginate" => [
                "first" => trans('general.datatable.sFirst'),
                "previous" => trans('general.datatable.sPrevious'),
                "next" => trans('general.datatable.sNext'),
                "last" => trans('general.datatable.sLast')
            ],
        ];
        return $langJson;
    }



    /**
     * Get query source of dataTable.
     *
     * @param \App\Models\SemesterExam $model
     * @return \Illuminate\Database\Eloquent\Builder
     */
    public function query(SemesterExam $model)
    {
        $allowedDivisions = [];
        $userPermission = Auth::guard('admin')->user()->getUserPermissionByCode('manage-exams');
        if ($userPermission) {
            $allowedDivisions = json_decode($userPermission['details'], true)['divisions'];
        }

        $query = $model->select('semester_exams.*', 'divisions.title as division', 'levels.title as level', 'study_materials.title  as study_material')
            ->join('divisions', 'divisions.id', '=', 'semester_exams.division_id')
            ->join('study_materials', 'study_materials.id', '=', 'semester_exams.study_material_id')
            ->join('levels', 'levels.id', '=', 'divisions.level_id');

        if (!in_array(-1, $allowedDivisions)) {
            $query =  $query->whereIn('semester_exams.division_id', $allowedDivisions);
        }

        return $query->orderBy('id', 'desc');
    }

    /**
     * Optional method if you want to use html builder.
     *
     * @return \Yajra\DataTables\Html\Builder
     */
    public function html()
    {
        return $this->builder()
            ->setTableId('exams-table')
            ->columns($this->getColumns())
            ->minifiedAjax()
            ->dom('<"d-flex justify-content-between align-items-center mx-0 row"<"col-sm-12 col-md-6"l><"col-sm-12 col-md-6"f>>t<"d-flex justify-content-between mx-0 row"<"col-sm-12 col-md-6"i><"col-sm-12 col-md-6"p>>')
            ->orderBy(0)
            ->buttons(
                Button::make('reset')->text(' <i class="fas fa-redo"></i> ' . trans('app.datatable.reset')),
                Button::make('reload')->text(' <i class="fas fa-sync-alt"></i> ' . trans('app.datatable.reload')),
            )->parameters([
                'responsive' => true,
                'autoWidth' => false,
                'lengthMenu' => [[10, 25, 50, 100], ['10', '25', '50', '100']],
                'language' => $this->lang(),
            ]);
    }

    /**
     * Get columns.
     *
     * @return array
     */
    protected function getColumns()
    {
        return [
            Column::computed('DT_RowIndex')->title('#')
                ->addClass('text-center'),
            Column::make('title')->title(trans('general.title')),
            Column::make('division')->title(trans('general.division')),
            Column::make('level')->title(trans('general.level')),
            Column::make('study_material')->title(trans('general.studyMaterial')),
            Column::make('quiz_mark')->title(trans('general.quiz_mark')),
            Column::make('quiz_type')->title(trans('general.quiz_type')),
            Column::make('created_at')->title(trans('general.created-at')),
            Column::computed('Action')->title(trans('general.options'))
                ->exportable(false)
                ->printable(false)
                ->addClass('text-center')
                ->searchable(false),
        ];
    }

    /**
     * Get filename for export.
     *
     * @return string
     */
    protected function filename()
    {
        return 'Exams_' . date('YmdHis');
    }
}
